package org.uacalc.example;

import org.uacalc.io.*;
import org.uacalc.alg.*;
import org.uacalc.terms.*;
import org.uacalc.eq.*;
import java.io.*;
import java.util.*;

public class AinVB {

  /**
   * @param args
   */
  //  static int[] algAGenerators = new int[] { 0, 1, 2 };
  public static void main(String[] args) {
    // TODO Auto-generated method stub
    if (args.length < 2) {
      System.out.println("need file names of two algebras");
      return;
    }
    SmallAlgebra algA = null;
    try {
      algA = AlgebraIO.readAlgebraFile(args[0]);
    }
    catch (IOException e) {}             // put an error message here.
    catch (BadAlgebraFileException e) {}
    SmallAlgebra algB = null;
    try {
      algB = AlgebraIO.readAlgebraFile(args[1]);
    }
    catch (IOException e) {}             // put an error message here.
    catch (BadAlgebraFileException e) {}
    final int[] algAGenerators = algA.sub().findMinimalSizedGeneratingSet().getArray();
    Equation eq = FreeAlgebra.findEquationOfAnotB(algB, algA, algAGenerators);
    System.out.println("eq is " + eq);
    if (eq != null) {  // if eq == null, algA is in V(algB), 
                       // or at least the subalgebra generated by the generators is.
      // test that eq fails in algA (of course it does).
      Map<Variable, Integer> failure = eq.findFailureMap(algA);
      System.out.println("failure in algA\n" + failure);
      // try to find a failure in algB (of course there is none).
      //failure = eq.findFailureMap(algB);
      //System.out.println("failure in algB\n" + failure);
    }
  }

}
